"use strict";
const GameObject = function(mesh) {
  this.mesh = mesh;
  this.position = new Vec2(0, 0);
  this.orientation = new Vec1(0);
  this.scale = new Vec3(1, 1, 1);
  this.modelMatrix = new Mat4();

  this.parent = undefined;
};

GameObject.prototype.updateModelTransformation = function(){
  this.modelMatrix.set().
    scale(this.scale).
    rotate(this.orientation.x).
    translate(this.position);
  if(this.parent !== undefined) {
    this.parent.updateModelTransformation();
    this.modelMatrix.mul(parent.modelMatrix);
  }
};

GameObject.prototype.draw = function(camera, time){
  this.updateModelTransformation();
  this.mesh.material.modelViewProjMatrix.set().
    mul(this.modelMatrix).
    mul(camera.viewProjMatrix);
  const texScale = this.mesh.material.texScale;
  const phase = Math.floor(time * this.animFreq) % (1 / texScale.x / texScale.y);
  this.mesh.material.texOffset.set( phase % (1 / texScale.x), Math.floor(phase / (1 / texScale.x)) );
  this.mesh.draw();
};

